package com.smfreports.activityreport;

import java.time.LocalDateTime;
import java.util.HashMap;
import java.util.Map;

import com.blackhillsoftware.smf.smf30.Smf30Record;

public class ActiveProgramEntry 
{
    public ActiveProgramEntry(String name)
    {
        programName = name;
    }    
    
    public void add(Smf30Record r30)
    {
        JobStep step = new JobStep(r30);
        LocalDateTime stepTime = r30.smfDateTime();
        LocalDateTime previous = jobSteps.get(step);
        if (previous == null || stepTime.isAfter(previous))
        {
            jobSteps.put(step, stepTime);
        }
    }

    public String getProgramName() {
        return programName;
    }
  
    public Map<JobStep, LocalDateTime> getJobSteps() {
        return jobSteps;
    }

    private Map<JobStep, LocalDateTime> jobSteps = new HashMap<>();
    private String programName;  
    
}
