package com.smfreports.activityreport;

import java.util.Objects;

import com.blackhillsoftware.smf.smf30.Smf30Record;

public class JobStep 
{
    public JobStep(Smf30Record r30)
    {
        jobname = r30.identificationSection().smf30jbn();
        stepnumber = r30.identificationSection().smf30stn();
        stepname = r30.identificationSection().smf30stm();
    }

    public String getJobname() {
        return jobname;
    }

    public int getStepnumber() {
        return stepnumber;
    }

    public String getStepname() {
        return stepname;
    }
    
    // hashCode and equals generated by Eclipse
    
    @Override
    public int hashCode() {
        return Objects.hash(jobname, stepnumber, stepname);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!(obj instanceof JobStep))
            return false;
        JobStep other = (JobStep) obj;
        return Objects.equals(jobname, other.jobname) 
                && stepnumber == other.stepnumber
                && Objects.equals(stepname, other.stepname);
    }

    private String jobname;
    private int stepnumber;
    private String stepname;
}
