package com.smfreports.cics;

import java.time.Duration;

import com.blackhillsoftware.smf.Utils;
import com.blackhillsoftware.smf.cics.monitoring.PerformanceRecord;
import com.blackhillsoftware.smf.cics.monitoring.fields.Field;

public class TransactionData 
{
    public void add(PerformanceRecord perfdata) 
    {
        count++;
        elapsed += Utils.ToSeconds(
                Duration.between(perfdata.getField(Field.START), perfdata.getField(Field.STOP)));
        dispatch += perfdata.getFieldTimerSeconds(Field.USRDISPT);
        dispatchWait += perfdata.getFieldTimerSeconds(Field.DISPWTT);
        cpu += perfdata.getFieldTimerSeconds(Field.USRCPUT);
    }

    public void add(TransactionData other) 
    {
        count += other.count;
        elapsed += other.elapsed;
        dispatch += other.dispatch;
        dispatchWait += other.dispatchWait;
        cpu += other.cpu;
    }
    
    public int getCount() 
    {
        return count;
    }

    public double getCpu() 
    {
        return cpu;
    }

    public Double getAvgElapsed() 
    {
        return count != 0 ? elapsed / count : null;
    }

    public Double getAvgDispatch() 
    {
        return count != 0 ? dispatch / count : null;
    }

    public Double getAvgDispatchWait() 
    {
        return count != 0 ? dispatchWait / count : null;
    }

    public Double getAvgCpu() 
    {
        return count != 0 ? cpu / count : null;
    }

    private int count = 0;
    private double elapsed = 0;
    private double dispatch = 0;
    private double dispatchWait = 0;
    private double cpu = 0;
}
